/**
  *
  * THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * COPYRIGHT 2007-2012 STMicroelectronics
  *
  ******************************************************************************
  */
#ifndef _APPCFG_
#define _APPCFG_

// ****************************************************************************
// ************************** Configuration Constants *************************
// ****************************************************************************    

    //constants to distiguish where to execute code from
    #define LOCATION_RAM           1
    #define LOCATION_FLASH         2

    //what type of compiler we use (see common.h for supported compilers)
    //Lets try to use automatic detection    
    #ifdef __MWERKS__    
        #define COMPILER        VENDOR_MWERKS    
    #elif defined(__GHS__)   
        #define COMPILER        VENDOR_GHS
    #else //autodetect failed - lets do it manualy
        #define COMPILER        VENDOR_GHS
    #endif

    // ************ Configure Application **************************************    

    //frequency of CPU clock [Hz]
    #define CPU_CLOCK       64000000
    #define CRYSTAL_CLOCK    8000000

    //what type of processor we use
    #define PROCESSOR     CPU_SPC560B

    //where do we want to run our test from,be aware to use the appropriate ILO file too
    #define EXECUTEFROM     LOCATION_FLASH
    //#define EXECUTEFROM     LOCATION_RAM
           

    // ************ Startup configuration  *************************************

    //Init RAM memory (only occupied memory will be initialized/zeroed. 
    //i.e. stack and data RAM)
    #define INIT_RAM
            
    //Init initialized variables. Uncomment define below to fill
    //initialize variables with values defined in ROM image
    //(This is valid only when locate_standalone_flash.ld and
    //initialized variables are going to be used)    
    #define INIT_RAM_VARIABLES

    #define SETUP_INTERRUPT_TABLES

#endif
// ****************************** End of appcfg.h *****************************
