/**
  *
  * THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * COPYRIGHT 2007-2012 STMicroelectronics
  *
  ******************************************************************************
  */

#ifndef _PLL_
#define _PLL_


// ****************************************************************************
// ************************** Configuration Constants *************************
// ****************************************************************************

//Precomputed constants for PLL setting based on CRYSTAL_CLOCK and CPU_CLOCK values
#if (PROCESSOR == CPU_SPC560B || PROCESSOR == CPU_SPC560P)
    #if (CRYSTAL_CLOCK == 8000000)
        #if (CPU_CLOCK == 12000000)
            #define FMPLL_NDIV     0x0030
            #define FMPLL_IDF      0x0001
            #define FMPLL_ODF      0x0003
        #elif (CPU_CLOCK == 16000000)
            #define FMPLL_NDIV     0x0020
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0003
        #elif (CPU_CLOCK == 32000000)
            #define FMPLL_NDIV     0x0020
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 40000000)
            #define FMPLL_NDIV     0x0028
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 50000000)
            #define FMPLL_NDIV     0x0032
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 60000000)
            #define FMPLL_NDIV     0x003C
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 64000000)
            #define FMPLL_NDIV     0x0020
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0001
        #else
            #error Unsupported CPU frequency(CPU_CLOCK) in appcfg.h. Use 12,16,32,40,50,60,64 MHz only!
        #endif
    #elif (CRYSTAL_CLOCK == 12000000)
        #if (CPU_CLOCK == 12000000)
            #define FMPLL_NDIV     0x0020
            #define FMPLL_IDF      0x0001
            #define FMPLL_ODF      0x0003
        #elif (CPU_CLOCK == 16000000)
            #define FMPLL_NDIV     0x0040
            #define FMPLL_IDF      0x0002
            #define FMPLL_ODF      0x0003
        #elif (CPU_CLOCK == 32000000)
            #define FMPLL_NDIV     0x0040
            #define FMPLL_IDF      0x0002
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 40000000)
            #define FMPLL_NDIV     0x0050
            #define FMPLL_IDF      0x0002
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 50000000)
            #define FMPLL_NDIV     0x0032
            #define FMPLL_IDF      0x0002
            #define FMPLL_ODF      0x0001
        #elif (CPU_CLOCK == 60000000)
            #define FMPLL_NDIV     0x0028
            #define FMPLL_IDF      0x0000
            #define FMPLL_ODF      0x0002
        #elif (CPU_CLOCK == 64000000)
            #define FMPLL_NDIV     0x0040
            #define FMPLL_IDF      0x0002
            #define FMPLL_ODF      0x0001
        #else
            #error Unsupported CPU frequency(CPU_CLOCK) in appcfg.h. Use 12,16,32,40,50,60,64 MHz only!
        #endif
    #else
        #error Unsupported crystal frequency(CRYSTAL_CLOCK) in appcfg.h. Use 8 or 12 MHz only!    
    #endif

#endif

#endif

// ***************************** End of pll.h *********************************
