#include "common.h"

void vPortTickISR(void);
void vPortISRHandler(void);
void vPortYield(void);
void STM0_InterruptHandler(void);

void dummy(void)
{
   for (;;)
      ;
}
/* Software vectors table */
#pragma asm
    .vle
	.section "._s_vect", "vax"

    .extern dummy
	.extern vPortISRHandler

ci: ; critical input
	e_b	dummy
	nop
	nop
	nop
mc: ; machine check
	e_b	dummy
	nop
	nop
	nop
ds:	; data storage
	e_b	dummy
	nop
	nop
	nop
is: ; instruction storage
	e_b	dummy
	nop
	nop
	nop
ei:	; external input
	e_b	vPortISRHandler
	nop
	nop
	nop
al: ; alignment
	e_b	dummy
	nop
	nop
	nop
pr: ; program
	e_b	dummy
	nop
	nop
	nop
fp: ; floating point
	e_b	dummy
	nop
	nop
	nop
sc: ; system call
	e_b	vPortYield
	nop
	nop
	nop
#pragma endasm

const uint32_t _hw_vectors[] __attribute__ ((section ("._h_vect")))= {
/* 0 */		(uint32_t)&dummy,		/* software interrupt 0 */
/* 1 */		(uint32_t)&dummy,		/* software interrupt 1 */
/* 2 */		(uint32_t)&dummy,		/* software interrupt 2 */
/* 3 */		(uint32_t)&dummy,		/* software interrupt 3 */
/* 4 */		(uint32_t)&dummy,		/* software interrupt 4 */
/* 5 */		(uint32_t)&dummy,		/* software interrupt 5 */
/* 6 */		(uint32_t)&dummy,		/* software interrupt 6 */
/* 7 */		(uint32_t)&dummy,		/* software interrupt 7 */
/* 8 */		(uint32_t)&dummy,		/* reserved */
/* 9 */		(uint32_t)&dummy,		/* flash error */
/* 10 */	(uint32_t)&dummy,		/* DMA combined error */
/* 11 */	(uint32_t)&dummy,		/* DMA interrupt 0 */
/* 12 */	(uint32_t)&dummy,		/* DMA interrupt 1 */
/* 13 */	(uint32_t)&dummy,		/* DMA interrupt 2 */
/* 14 */	(uint32_t)&dummy,		/* DMA interrupt 3 */
/* 15 */	(uint32_t)&dummy,		/* DMA interrupt 4 */
/* 16 */	(uint32_t)&dummy,		/* DMA interrupt 5 */
/* 17 */	(uint32_t)&dummy,		/* DMA interrupt 6 */
/* 18 */	(uint32_t)&dummy,		/* DMA interrupt 7 */
/* 19 */	(uint32_t)&dummy,		/* DMA interrupt 8 */
/* 20 */	(uint32_t)&dummy,		/* DMA interrupt 9 */
/* 21 */	(uint32_t)&dummy,		/* DMA interrupt 10 */
/* 22 */	(uint32_t)&dummy,		/* DMA interrupt 11 */
/* 23 */	(uint32_t)&dummy,		/* DMA interrupt 12 */
/* 24 */	(uint32_t)&dummy,		/* DMA interrupt 13 */
/* 25 */	(uint32_t)&dummy,		/* DMA interrupt 14 */
/* 26 */	(uint32_t)&dummy,		/* DMA interrupt 15 */
/* 27 */	(uint32_t)&dummy, 		/* reserved */
/* 28 */	(uint32_t)&dummy, 		/* software watchdog */
/* 29 */	(uint32_t)&dummy, 		/* reserved */
/* 30 */	(uint32_t)&STM0_InterruptHandler,		/* STM channel 0 */
/* 31 */	(uint32_t)&dummy,		/* STM channel 1 */
/* 32 */	(uint32_t)&dummy,		/* STM channel 2 */
/* 33 */	(uint32_t)&dummy,		/* STM channel 3 */
/* 34 */	(uint32_t)&dummy,		/* reserved */
/* 35 */	(uint32_t)&dummy,		/* DBD ecc */
/* 36 */	(uint32_t)&dummy,		/* SBC ecc */
/* 37-40 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 41 */	(uint32_t)&dummy,		/* SIU external 0 */
/* 42 */	(uint32_t)&dummy,		/* SIU external 1 */
/* 43 */	(uint32_t)&dummy,		/* SIU external 2 */
/* 44 */	(uint32_t)&dummy,		/* SIU external 3 */
/* 45-48 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 49-50 */	(uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 51 */	(uint32_t)&dummy,		/* safe mode interrupt */
/* 52 */	(uint32_t)&dummy,		/* mode transition interrupt */
/* 53 */	(uint32_t)&dummy,		/* invalid mode interrupt */
/* 54 */	(uint32_t)&dummy,		/* invalid mode config */
/* 55 */	(uint32_t)&dummy,		/* reserved */
/* 56 */	(uint32_t)&dummy,		/* alternate event interrupt */
/* 57 */	(uint32_t)&dummy,		/* XOSC counter expired */
/* 58 */	(uint32_t)&dummy,		/* reserved */
/* 59 */	(uint32_t)&vPortTickISR,		/* PIT channel 0 */
/* 60 */	(uint32_t)&dummy,		/* PIT channel 1 */
/* 61 */	(uint32_t)&dummy,		/* PIT channel 2 */
/* 62 */	(uint32_t)&dummy,		/* ADC 0 end of conversion */
/* 63 */	(uint32_t)&dummy,		/* ADC 0 error */
/* 64 */	(uint32_t)&dummy,		/* ADC 0 wd */
/* 65 */	(uint32_t)&dummy,		/* FLEXCAN 0 esr.int */
/* 66 */	(uint32_t)&dummy,		/* FLEXCAN 0 esr.boff */
/* 67 */	(uint32_t)&dummy,		/* FLEXCAN 0 esr.wak */
/* 68 */	(uint32_t)&dummy,		/* FLEXCAN 0 buf 0-3 */
/* 69 */	(uint32_t)&dummy,		/* FLEXCAN 0 buf 4-7 */
/* 70 */	(uint32_t)&dummy,		/* FLEXCAN 0 buf 8-11 */
/* 71 */	(uint32_t)&dummy,		/* FLEXCAN 0 buf 12-15 */
/* 72 */	(uint32_t)&dummy,		/* FLEXCAN 0 buf 16-31 */
/* 73 */	(uint32_t)&dummy,		/* reserved */
/* 74 */	(uint32_t)&dummy,		/* DSPI 0 error */
/* 75 */	(uint32_t)&dummy,		/* DSPI 0 transmit end-of-queue */
/* 76 */	(uint32_t)&dummy,		/* DSPI 0 transmit fill */
/* 77 */	(uint32_t)&dummy,		/* DSPI 0 tranfer complete */
/* 78 */	(uint32_t)&dummy,		/* DSPI 0 receive drain */
/* 79 */	(uint32_t)&dummy,		/* LIN 0 receive */
/* 80 */	(uint32_t)&dummy,		/* LIN 0 transmit */
/* 81 */	(uint32_t)&dummy,		/* LIN 0 error */
/* 82 */	(uint32_t)&dummy,		/* ADC 1 end of conversion */
/* 83 */	(uint32_t)&dummy,		/* ADC 1 error */
/* 84 */	(uint32_t)&dummy,		/* ADC 1 wd */
/* 85-88 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 89-92 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 93 */	(uint32_t)&dummy,		/* reserved */
/* 94 */	(uint32_t)&dummy,		/* DSPI 1 error */
/* 95 */	(uint32_t)&dummy,		/* DSPI 1 transmit end-of-queue */
/* 96 */	(uint32_t)&dummy,		/* DSPI 1 transmit fill */
/* 97 */	(uint32_t)&dummy,		/* DSPI 1 tranfer complete */
/* 98 */	(uint32_t)&dummy,		/* DSPI 1 receive drain */
/* 99 */	(uint32_t)&dummy,		/* LIN 1 receive */
/* 100 */	(uint32_t)&dummy,		/* LIN 1 transmit */
/* 101 */	(uint32_t)&dummy,		/* LIN 1 error */
/* 102-105 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 106-109 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 110-113 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 114 */	(uint32_t)&dummy,		/* DSPI 2 error */
/* 115 */	(uint32_t)&dummy,		/* DSPI 2 transmit end-of-queue */
/* 116 */	(uint32_t)&dummy,		/* DSPI 2 transmit fill */
/* 117 */	(uint32_t)&dummy,		/* DSPI 2 tranfer complete */
/* 118 */	(uint32_t)&dummy,		/* DSPI 2 receive drain */
/* 119-122 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 123-126 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 127 */	(uint32_t)&dummy,		/* PIT channel 3 */
/* 128-131 */	(uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
/* 132 */	(uint32_t)&dummy,		/* reserved */
/* 133 */	(uint32_t)&dummy,		/* FlexRay FNEAIF */
/* 134 */	(uint32_t)&dummy,		/* FlexRay FNEBIF */
/* 135 */	(uint32_t)&dummy,		/* FlexRay WUPIF */
/* 136 */	(uint32_t)&dummy,		/* FlexRay PRIF */
/* 137 */	(uint32_t)&dummy,		/* FlexRay CHIF */
/* 138 */	(uint32_t)&dummy,		/* FlexRay TBIF */
/* 139 */	(uint32_t)&dummy,		/* FlexRay RBIF */
/* 140 */	(uint32_t)&dummy,		/* FlexRay MIF */
/* 141-142 */	(uint32_t)&dummy, (uint32_t)&dummy,	/* reserved */
};
