/**
  *
  * THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * COPYRIGHT 2007-2012 STMicroelectronics
  *
  ******************************************************************************
  */
#ifndef _COMMON_
#define _COMMON_

    #include "types.h"

// ****************************************************************************
// ************************* Supported MCUs and compilers *********************
// ****************************************************************************

    #define CPU_SPC560B         289

//constants for different compilers    
    #define VENDOR_GHS          10      //GreenHills
    #define VENDOR_MWERKS       15      //MetroWerks
    #define VENDOR_GCC          20      //GNUCompilerCollection

// ****************************************************************************
// ************************** Constants and Variables *************************
// ****************************************************************************

    //general error codes
    #define OK              0
    #define FAIL            0xFFFF
    #define TIMEOUT         0xFF

    //boolean constants
    #define TRUE     1
    #define FALSE    0

    //Single bit masks
    #define MASK_BIT0   0x0001
    #define MASK_BIT1   0x0002
    #define MASK_BIT2   0x0004
    #define MASK_BIT3   0x0008
    #define MASK_BIT4   0x0010
    #define MASK_BIT5   0x0020
    #define MASK_BIT6   0x0040
    #define MASK_BIT7   0x0080
    #define MASK_BIT8   0x0100
    #define MASK_BIT9   0x0200
    #define MASK_BIT10  0x0400
    #define MASK_BIT11  0x0800
    #define MASK_BIT12  0x1000
    #define MASK_BIT13  0x2000
    #define MASK_BIT14  0x4000
    #define MASK_BIT15  0x8000
    
    #define MASK_BIT16  0x00010000
    #define MASK_BIT17  0x00020000
    #define MASK_BIT18  0x00040000
    #define MASK_BIT19  0x00080000
    #define MASK_BIT20  0x00100000
    #define MASK_BIT21  0x00200000
    #define MASK_BIT22  0x00400000
    #define MASK_BIT23  0x00800000
    #define MASK_BIT24  0x01000000
    #define MASK_BIT25  0x02000000
    #define MASK_BIT26  0x04000000
    #define MASK_BIT27  0x08000000
    #define MASK_BIT28  0x10000000
    #define MASK_BIT29  0x20000000
    #define MASK_BIT30  0x40000000
    #define MASK_BIT31  0x80000000

    //simple utility functions
    #define MIN(a,b) (((a) > (b))?(b):(a))
    #define MAX(a,b) (((a) > (b))?(a):(b))
    
    
    //4byte LITLLE2BIG endiand swap
    #define ORDERING_LITTLE2BIG_32(value32) {\
                register UINT32 tmp;\
                tmp = value32;\
                value32 = ((tmp & 0x000000FF)<< 24) |\
            	((tmp & 0x0000FF00)<<  8) |\
            	((tmp & 0x00FF0000)>>  8) |\
            	((tmp & 0xFF000000)>> 24);\
            }
    //2byte LITLLE2BIG endiand swap
    #define ORDERING_LITTLE2BIG_16(value16) {\
                register UINT16 tmp;\
                tmp = value16;\
                value16 = ((tmp & 0x00FF)<< 8) |\
            	          ((tmp & 0xFF00)>> 8); \
            }
    
    __inline asm void _nop(void){
        nop
    } 

    inline void msync(void){
        #pragma asm
            msync
        #pragma endasm
    }    

    #include "appcfg.h"

    #ifndef COMPILER
        #error "common.h: COMPILER is not defined"
    #endif

    #ifndef PROCESSOR
        #error "common.h: PROCESSOR is not defined"
    #endif    

    #include "ports.h"
    
// ****************************************************************************
// ********************** MCU specific headers and definitions ****************
// ****************************************************************************
   #if ( COMPILER == VENDOR_GHS )
       #include <ppc_ghs.h>
   #endif 

    //include header file with processor specific registers

   #include "spc560B_spr.h"
   #include "spc560bsp.h"

#endif

// ***************************** End of common.h ******************************
